﻿# coding:utf-8
import controlTypes
# controlTypes module compatibility with old versions of NVDA
if not hasattr(controlTypes, "Role"):
	setattr(controlTypes, "Role", type('Enum', (), dict(
	[(x.split("ROLE_")[1], getattr(controlTypes, x)) for x in dir(controlTypes) if x.startswith("ROLE_")])))
	setattr(controlTypes, "State", type('Enum', (), dict(
	[(x.split("STATE_")[1], getattr(controlTypes, x)) for x in dir(controlTypes) if x.startswith("STATE_")])))
	setattr(controlTypes, "role", type("role", (), {"_roleLabels": controlTypes.roleLabels}))
# End of compatibility fixes
from tones import beep
from re import compile
#from synthDriverHandler  import getSynth
#from logHandler import log
from datetime import datetime
from ui import message
from gui import mainFrame  
from keyboardHandler import KeyboardInputGesture
import globalVars
#from globalCommands import commands
from time import sleep, mktime
from winsound import PlaySound,SND_MEMORY, SND_PURGE, MessageBeep,MB_ICONASTERISK
import threading
objSoundFiles = {}
import speech
#import zDevTools as z
from wx import CallAfter, CallLater, Menu, MessageBox
#from winUser import mouse_event, MOUSEEVENTF_RIGHTDOWN, MOUSEEVENTF_RIGHTUP, MOUSEEVENTF_LEFTDOWN, MOUSEEVENTF_LEFTUP, 
from winUser import setCursorPos
import addonHandler,  os, sys
import api
#from api import setMouseObject, getMouseObject, moveMouseToNVDAObject, getClipData, 
from api import copyToClip
#from NVDAObjects.IAccessible import getNVDAObjectFromPoint 
from UIAHandler import handler,UIA_LegacyIAccessibleRolePropertyId, UIA_LegacyIAccessibleStatePropertyId, TreeScope_Children, UIA_ButtonControlTypeId, UIA_ControlTypePropertyId, IUIAutomationInvokePattern, UIA_LegacyIAccessibleKeyboardShortcutPropertyId, TreeScope_Descendants, UIA_SeparatorControlTypeId, UIA_TabItemControlTypeId,UIA_LegacyIAccessibleDescriptionPropertyId 
clientObject =handler.clientObject
GetPreviousSiblingElement = clientObject.RawViewWalker.GetPreviousSiblingElement
GetFirstChildElement  = clientObject.RawViewWalker.GetFirstChildElement
GetNextSiblingElement =clientObject.RawViewWalker.GetNextSiblingElement
#from oleacc import STATE_SYSTEM_MARQUEED, STATE_SYSTEM_PRESSED, STATE_SYSTEM_FOCUSABLE, STATE_SYSTEM_SELECTED, STATE_SYSTEM_SELECTABLE, GetRoleText, ROLE_SYSTEM_PAGETAB, ROLE_SYSTEM_GROUPING, STATE_SYSTEM_OFFSCREEN

#from oleacc import ROLE_SYSTEM_ALERT
#from gui import mainFrame

import sharedVars
prevSpeechMode = False

def isChichi() :
	if sharedVars.chichi is not None : return sharedVars.chichi
	# level 4,     6 of 7, name : chichi, Role.BUTTON, IA2ID : chichi_free_fr-browserAction-toolbarbutton Tag: toolbarbutton, States :  Path : Role-FRAME| i46, Role-GROUPING, , IA2ID : tabpanelcontainer | i0, Role-PROPERTYPAGE, , IA2ID : mailContent | i0, Role-TOOLBAR, , IA2ID : mail-bar3 | i6, Role-BUTTON, , IA2ID : chichi_free_fr-browserAction-toolbarbutton , IA2Attr : tag : toolbarbutton, id : chichi_free_fr-browserAction-toolbarbutton, class : toolbarbutton-1 webextension-action, explicit-name : true, setsize : 2, display : -moz-box, posinset : 1, , Actions : press,  ;
	o = getPropertyPageFromFG()
	# sharedVars.log(o, "prop page : ")
	if not o or o.role == controlTypes.Role.FRAME : return False
	# i0, Role-TOOLBAR, , IA2ID : mail-bar3 | i6, Role-BUTTON, , IA2ID : chichi_free_fr-browserAction-toolbarbutton
	o =  findChildByID(o, "mail-bar3")
	# sharedVars.log(o, "Toolbar : ")
	if not o : return False
	o = findChildByID(o, "chichi_free_fr-browserAction-toolbarbutton")
	# sharedVars.log(o, "Bouton  : ")
	sharedVars.chichi = (True if o else False)
	sharedVars.log(o, "Chichi : " + str(sharedVars.chichi))
	return sharedVars.chichi
def noSpeechMessage(msg) :
	speech.cancelSpeech()
	message(msg)
def playSound (soundFile): 
	try :
		threading.Thread (None, PlaySound, None, (objSoundFiles[(soundFile if soundFile.endswith (".wav") else soundFile+".wav")],SND_MEMORY|SND_PURGE)).start ()
	except : 
		beep(440, 80)
		pass #son non trouvé


def versionTB() :   
	return int(globalVars.foregroundObject.appModule.productVersion.split(".") [0])

def TBVersion() : # full version string
	return globalVars.foregroundObject.appModule.productVersion

def addonVersion(sp="%20") :
	_curAddon = addonHandler.getCodeAddon()
	name = _curAddon.manifest["name"]
	ver = _curAddon.manifest["version"]
	return  name + sp + ver.split(" ")[0]

# new speechMode functions by Paulber19 for NVDA 2021.1+ ander previous 
def getSpeechMode():
	try:
		# for nvda version >= 2021.1
		return speech.getState().speechMode
	except AttributeError:
		return speech.speechMode

def setSpeechMode(mode):
	try:
		# for nvda version >= 2021.1
		speech.setSpeechMode(mode)
	except AttributeError:
		speech.speechMode = mode


def setSpeechMode_off():
	#print(u"Fonction setSpeechMode_off")
	try:
		# for nvda version >= 2021.1
		speech.setSpeechMode(speech.SpeechMode.off)
	except AttributeError:
		speech.speechMode = speech.speechMode_off


def setSpeech(enable) :
	global 		prevSpeechMode
	if enable and  prevSpeechMode :
		setSpeechMode(prevSpeechMode)
		prevSpeechMode = None
	elif not enable :
		prevSpeechMode = getSpeechMode()
		setSpeechMode_off()

def getIA2Attribute (obj,attribute_value=False,attribute_name ="id"):
	r= hasattr (obj,"IA2Attributes") and attribute_name in obj.IA2Attributes.keys ()
	if not r :return False
	r =obj.IA2Attributes[attribute_name]
	return r if not attribute_value  else r ==attribute_value

def findChildByID(obj,id) : # attention : valeurs role de controlTypes.py
	try : 
		prevLooping = sharedVars.objLooping
		sharedVars.objLooping = True
		try:
			o = obj.firstChild
		except :
			return None
		while o:
			ia2ID = str(getIA2Attribute(o))  # get_ia2Id(o)	
			if  ia2ID ==  id:
				return o
			try:
				o= o.next
			except:
				o = None
		return None	
	finally :
		sharedVars.objLooping = prevLooping
	
def findChildByIDRev(obj,id) : # attention : valeurs role de controlTypes.py
	try : 
		prevLooping = sharedVars.objLooping
		sharedVars.objLooping = True
		try:
			o = obj.lastChild
		except :
			return None
		while o:
			ia2ID = str(getIA2Attribute(o)) # get_ia2Id(o)	
			if  ia2ID ==  id:
				return o
			try:
				o= o.previous
			except:
				o = None
		return None	
	finally :
		sharedVars.objLooping = prevLooping

def findParentByID(o, role, ID) :
	try : 
		prevLooping = sharedVars.objLooping
		sharedVars.objLooping = True
		while o :
			if sharedVars.debug : sharedVars.log(o, " parent ", False)
			if o.role == role :
				if str(getIA2Attribute(o)) == ID :
					return o
			o = o.parent

		return None
	finally :
		sharedVars.objLooping = prevLooping
def formatDateTime (d):
	return d
	"""if not d.count (":"):return d
	elif d and not d.count("/"):return u" aujourdhui à" +formatTime (d.split (":"))
	date =d.split (" ")
	date_original =date[0]
	date, time = date[0].split ("/"), date[1].split (":")
	date =datetime (int (date[2]), int (date[1]), int (date[0]))
	return weekDay[date.weekday ()]+" "+date_original+u" à " +formatTime (time)"""

def hasTabPanel(frame=None) :
	try :
		sharedVars.objLooping = True
		if not frame :
			frame = globalVars.foregroundObject
		o = frame.lastChild
		while o :
			#beep(100, 2)
			#if sharedVars.debug : sharedVars.log(o, " frame child " + str(i))
			if o.role  == controlTypes.Role.GROUPING :
				if str(getIA2Attribute(o)) == "tabpanelcontainer" : 
					return True
			if o.previous : o = o.previous
			else : o = None
		return False
	finally :
		sharedVars.objLoping = False
def getObjFirstGrouping (self): 
	#if not api.getForegroundObject():return getObjFirstGrouping2 (self) # modif PL
	try :
		o = clientObject.ElementFromHandle (api.getForegroundObject().windowHandle)
		o=o.FindFirst(TreeScope_Children,clientObject.CreatePropertyCondition (UIA_LegacyIAccessibleRolePropertyId  , 22)) #barre d'outilTB
		if o and GetNextSiblingElement(o):
			o=GetNextSiblingElement(o)
			if o.GetCurrentPropertyValue(30095)==22 : o=GetNextSiblingElement(o)
			o= GetFirstChildElement(o)
		else :
			oo=api.getForegroundObject()
			oo= findChildByID(oo,"tabpanelcontainer") 
			oo= findChildByID(oo,"mailContent") 
			oo=oo.firstChild
			(x,y,l,h)=oo.location
			from ctypes.wintypes import POINT, RECT
			o=clientObject.ElementFromPoint(POINT(int(x)+40,int(y)+8)) # bouton relever
			while o and  o.GetCurrentPropertyValue (30095)!=38:
				o=clientObject.ControlViewWalker.GetParentElement(o)
		if o and o.GetCurrentPropertyValue (30095)==38 : return o
		else : return False
	except :
		MessageBeep
		return False
		
def getObjFirstGrouping2 (self): 
	try :
		o = clientObject.ElementFromHandle (api.getFocusObject().windowHandle).FindFirst(TreeScope_Children,clientObject.CreateAndCondition (clientObject.CreatePropertyCondition (30095,38),clientObject.CreatePropertyCondition (30011,"mailContent" )))
		return o
	except :
		try :
			oo=api.getForegroundObject()
			oo= findChildByID(oo,"tabpanelcontainer") 
			oo= findChildByID(oo,"mailContent") 
			oo=oo.firstChild
			(x,y,l,h)=oo.location
			from ctypes.wintypes import POINT, RECT
			o=clientObject.ElementFromPoint(POINT(int(x)+40,int(y)+8)) # bouton relever
			while o and not o.GetCurrentPropertyValue(30095)==38 : #page propriétés
				o=clientObject.RawViewWalker.getParentElement(o)
			if o and clientObject.RawViewWalker.GetParentElement(o).GetCurrentPropertyValue(30095)==20 :
				return o
		except :	
			# print (u" !!! problème firstGrouping 2  !!!")	
			return  False		
def getElementWalker(o,n):
	walker=clientObject.createTreeWalker(clientObject.CreateTrueCondition ())
	if n==4 :o=walker.getParentElement(o)
	elif n==5 :o=walker.getNextSiblingElement(o)
	elif n==6 :o=walker.getPreviousSiblingElement(o)
	elif n==7 :o=walker.getFirstChildElement(o)
	elif n==8 :o=walker.getLastChildElement(o)
	return o
	
			
# Pour  TB91 :   l'ID "messengerWindow" a disparu du frame de la fenêtre principale
# ID=compose-toolbar-menubar2, role TOOLBAR=35  

# def getExpandedHeaders (startObj=None) :
	# if not startObj :
		# o = getIAPropertyPage() # get property page  if found else frame object
	# else :
		# o = startObj
	# role = (o.role if o else 0)
	# # v3 : cherche d'abord dans fenêtre séparée de lecture : FRAME=34|, role TABLE=28 expandedHeaders, 
	# if role == 34 : # fenêtre lecture
		# # v3 fix
		# child = o.getChild(20)  #  pour gain de vitesse
		# if not child : 
			# o = o.firstChild
		# else : 
			# o = child
		# while o :
			# if o.role == 28 : # table
				# if str(getIA2Attribute(o)) == "expandedHeaders" : 
					# return o
			# o = o.next
		# return False
	# # fenêtre principale
	# if role != controlTypes.Role.PROPERTYPAGE : # property page
		# message (u"property page non trouvée")
		# return
	# id = getIA2Attribute(o)
	# #message ("id=" + str(id))
	# if id not in  ("mailContent", "messengerWindow") : return None
	# # TB 78 : niveau 4, 10 sur 14, ID=expandedHeaders, role TABLE=28, childCount=1, sans nom, Chemin : role WINDOW=1|, role FRAME=34 messengerWindow|, role GROUPING=56 tabpanelcontainer|, role PROPERTYPAGE=57 mailContent|, role TABLE=28 expandedHeaders ;
	# # TB 68 : niveau 4, 5 sur 122, ID=expandedfromLabel, role LABEL=73, childCount=1, nom=De, Chemin : role WINDOW=1|, role FRAME=34 messengerWindow|, role GROUPING=56 tabpanelcontainer|, role PROPERTYPAGE=57 mailContent|, role LABEL=73 expandedfromLabel ;
	# isNewTB = True
	# findRole = 28   # controlTypes.Role.TABLE
	# findID = "expandedHeaders"
	# o = o.firstChild
	# while o :
		# if o.role == findRole :
			# id = getIA2Attribute(o)
			# #message ("id=" + str(id))
			# if id == findID :
				# #message(u"expandedHeaders trouvé")
				# return o
		# o = o.next
	# message (u"Le panneau de lecture n'est pas affiché. Veuillez presser F8 puis réessayer.")
	# return None

def getExpandedHeadersFromFO(o, num="") :
	try :
		prevLooping = sharedVars.objLooping
		sharedVars.objLooping = True
		
		ID =     "expandedHeaders" + num 
		if o.role in (controlTypes.Role.TREEVIEWITEM, controlTypes.Role.TABLEROW) : # liste messages 
			o2 = o.parent.parent # role-PROPERTYPAGE=57, , IA2ID : mailContent 
		elif controlTypes.Role.DOCUMENT : 
			o2 = o.parent.parent # role frame  = 34
		elif role in (controlTypes.Role.UNKNOWN, controlTypes.Role.BUTTON) :
			while  o :
				if o.role == controlTypes.Role.TABLE : return o
				if o.role in (controlTypes.Role.FRAME, controlTypes.Role.PROPERTYPAGE) : return -1
				o = o.parent
			return -1
			return -1 # retry
		o2 = o2.lastChild 
		# cherche : Niveau 3,    11 sur 19, role.TABLE=28, IA2ID : expandedHeaders Tag: table, états : , childCount  : 2 Chemin : role FRAME=34| i37, role-GROUPING=56, , IA2ID : tabpanelcontainer | i0, role-PROPERTYPAGE=57, , IA2ID : mailContent | i11, role-TABLE=28, , IA2ID : expandedHeaders , IA2Attr : id : expandedHeaders, layout-guess : true, tag : table, display : inline-grid,  ;
		while o2 :
			if o2.role == controlTypes.Role.TABLE :
				if str(getIA2Attribute(o2)) == ID  :
					return o2
			o2 = o2.previous
	finally :
		sharedVars.objLooping = prevLooping

def getIAPropertyPage (o=None) :
	# retturns the propertypage obj if found otherwise an obj of an upper level, ie. role frame = 34
	r = None
	if not o :
		o = api.getFocusObject()
		# search role frame=34
	while o :
		if o.role ==controlTypes.Role.FRAME :
			r = o
			break
		o = o.parent
	if not o : return None
	#   niveau 2, 47 sur 50, ID=tabpanelcontainer, role GROUPING=56, childCount=2, sans nom, Chemin : role WINDOW=1|, role FRAME=34 messengerWindow|, role GROUPING=56 tabpanelcontainer ;
	# search role GROUPING=56 tabpanelcontainer
	o = o.lastChild 
	while o :
		if o.role == controlTypes.Role.GROUPING : # 56
			if getIA2Attribute(o)  == "tabpanelcontainer" : 
				r = o
				break
		o = o.previous
	if not o : return r
	# search role 57 property page , ID in  ("mailContent", "messengerWindow") :
	o = o.firstChild
	while o :
		if o.role == controlTypes.Role.PROPERTYPAGE :
			if  getIA2Attribute(o) ==  "mailContent" :
				return o
	return r

def getPropertyPageFromFG() :
	try :
		sharedVars.objLooping = True
		fg =  globalVars.foregroundObject
		# 0 sur 3, role.PROPERTYPAGE=57, IA2ID : mailContent Tag: box, états : , childCount  : 3 Chemin : role FRAME=34| i37, role-GROUPING=56, , IA2ID : tabpanelcontainer | i0, role-PROPERTYPAGE=57, , IA2ID : mailContent , IA2Attr : id : mailContent, display : -moz-box, tag : box,  ;
		o = fg.lastChild
		while o : 
			if o.role  == controlTypes.Role.GROUPING :
				break
			if o.previous :
				o = o.previous
			else : o = None
		if not o :  # no grouping, search other frame
			#  role FRAME=34| i23, role-INTERNALFRAME=115, , IA2ID : content-frame | 
			o = fg.lastChild.previous
		#ID =  getIA2Attribute(o)
		# search propertypage
		o = o.firstChild
		if not o : return fg
		if o.role == controlTypes.Role.PROPERTYPAGE :
			return o
		else :
			return fg
	finally :
		sharedVars.objLooping = False

def getMessageHeadersFromFG(reportNotOpen=True) :
	# look for in main window : 7 sur 8, role.LANDMARK = 149, IA2ID : messageHeader Tag: header, états : , childCount  : 5 Chemin : role FRAME=34| i47, role-GROUPING=56, , IA2ID : tabpanelcontainer | i0, role-PROPERTYPAGE=57, , IA2ID : mailContent | i7, role-LANDMARK = 149, , IA2ID : messageHeader , IA2Attr : display : grid, id : messageHeader, tag : header, xml-roles : banner, class : message-header-container, , Actions : click ancestor,  ;
	# in separate msg window : 19 sur 21, role.LANDMARK = 149, IA2ID : messageHeader Tag: header, états : , childCount  : 5 Chemin : role FRAME=34| i19, role-LANDMARK = 149, , IA2ID : messageHeader , IA2Attr : display : grid, id : messageHeader, tag : header, xml-roles : banner, class : message-header-container, , Actions : click ancestor,  ; 
	o = getPropertyPageFromFG() # returns  a property  page object if found otherwise a frame object
	# sepWnd = (True if o.role == controlTypes.Role.FRAME else False)
	o = o.lastChild
	while o :
		if o.role == controlTypes.Role.LANDMARK : # table ID= expandedHeaders
			if str(getIA2Attribute(o)) == "messageHeader" : 
				return o # , sepWnd
		o = o.previous
	return None # , sepWnd
	
def strBetween(txt, sep1, sep2) :
	pos1 = txt.find(sep1) 
	if pos1 < 0 : return ""
	pos2 = txt.find(sep2, pos1)
	if  pos2 < 0 : return ""
	return txt[pos1+1:pos2]

def getStatusBarText() :
	o = globalVars.foregroundObject # frame
	t = ""
	o = o.lastChild
	while o :
		if o.role == controlTypes.Role.STATUSBAR :
			break
		o = o.previous
	if not o : return u"La barre d'état n'est pas affichée."
	o = o.firstChild
	while o :
		if o.role != controlTypes.Role.BUTTON :
			if hasattr(o, "name") :
				if o.name : t += str(o.name ) + ", "
		o = o.next
	return t

def sendKey(keyName, num=1, delay=0.01) :
	i = 1
	while i <= num :
		# sharedVars.log(None, "sendKey, i " + str(i) + ", num " + str(num))
		KeyboardInputGesture.fromName(keyName).send()
		if i < num : sleep(delay)
		i += 1

def showNVDAMenu (menu):
	setCursorPos(300,300)
	sleep(0.03)
	CallAfter (displayMenu,menu)
def displayMenu (menu):
	mainFrame.prePopup ()
	mainFrame.PopupMenu (menu)
	mainFrame.postPopup ()

def toolBarClickButton (toolBar, buttonIndex): toolBar.FindAll (TreeScope_Children, clientObject.CreatePropertyCondition (UIA_ControlTypePropertyId,  UIA_ButtonControlTypeId)).GetElement (buttonIndex).GetCurrentPattern (10000 ).QueryInterface (IUIAutomationInvokePattern).Invoke ()
def alertClickButton(objStart, evt):
	hk =evt.GetEventObject ().GetLabelText (evt.Id).split (" ")[-1]
	if not hk.count ("+"):
		o= GetNextSiblingElement ( objStart.FindFirst (TreeScope_Descendants , clientObject.CreateAndCondition (clientObject.CreatePropertyCondition (UIA_ControlTypePropertyId, UIA_ButtonControlTypeId),clientObject.CreatePropertyCondition (UIA_LegacyIAccessibleKeyboardShortcutPropertyId, evt.GetEventObject().GetLabelText (evt.Id-1).split (" ")[-1]))))
	else:
		o= objStart.FindFirst (TreeScope_Descendants , clientObject.CreateAndCondition (clientObject.CreatePropertyCondition (UIA_ControlTypePropertyId, UIA_ButtonControlTypeId),clientObject.CreatePropertyCondition (UIA_LegacyIAccessibleKeyboardShortcutPropertyId, evt.GetEventObject().GetLabelText (evt.Id).split (" ")[-1])))
	CallAfter (o.GetCurrentPattern (10000 ).QueryInterface (IUIAutomationInvokePattern).Invoke)

def formatTime (time):
	"""h, m=int (time[0]), int (time[1])
	#>>h =("minuit" if not h else h)
	#h>>=("midi" if h ==12 else h )
	m=(" " if not m else m)
	if m :
		time =("{h} heure {m}".format (h=h, m=m) if str (h).isdigit () else str (h)+" "+str (m))
	else:
		time =h"""
	return time
	
def  getTimeStamp  (t):
	if t.count ("/"):
		t =t.replace ("/"," ").replace (":"," ").split (" ")
		day,month, year, hour, minute =[int (e) for e in t]
	else:
		t, now =[int (e) for e in t.split (":")], datetime.now ()
		day, month, year, hour, minute = now.day, now.month, now.year, t[0], t[1]
	return  float (mktime (datetime  (year =year,month =month, day =day, hour =hour, minute=minute).timetuple ()))
	

# *******
def inputBox (label, title, postFunction, startValue=""):
	import gui
	import wx
	d = wx.TextEntryDialog(
		gui.mainFrame,
		label,
		title,
		style = wx.OK | wx.CANCEL)
	d.Value = str(startValue)
	def callback(result):
		if result == wx.ID_OK:
			# On a validé sur OK, d.Value récupère le contenu de la saisie, on peut l'analyser ici.
			if postFunction :
				wx.CallAfter(postFunction, d.Value)
			else : 
				copyToClip(d.Value)
				message(u"Copié")
				sleep(0.4)
		else :
			wx.CallAfter(postFunction, "ibCancel")
	gui.runScriptModalDialog(d, callback)
	#CallAfter(KeyboardInputGesture.fromName ("control+a").send) 

import inspect
def getStack(msg, min=1) :
	t = msg 
	stk =  inspect.stack()
	max = len(stk)
	if min < 0 : min = max + min
	for i in range(min, max) :
		t = t + " fonction  : {0}, {1}, {2}, {3}".format(stk[i][0], stk[i][1], stk[i][2], stk[i][3])
	return t

def openListAttachment2 (fo, repeat ):
	oPP = getPropertyPageFromFG() # return pp if main window else frame if separate message window
	if not oPP : return
	#cherche les objets d'ID attachmentCount 
	# 8 sur 12, name : 1 pièce jointe :, role.LABEL=73, IA2ID : attachmentCount    Chemin : role FRAME=34| i46, role-GROUPING=56, , IA2ID : tabpanelcontainer | i0, role-PROPERTYPAGE=57, , IA2ID : mailContent | i8, role-LABEL=73, , IA2ID : attachmentCount , IA2Attr : explicit-name : true, id : attachmentCount, tag : label, display : inline-block, , Actions : click,  ;
	o = findChildByIDRev(oPP, "attachmentCount")	
	if not o :
		message (_(u"Pas de pièce jointe."))
		return False
	# il y a 1 ou plusieurs  PJ
	message(o.name)
	if repeat == 0 : return True
	# on doit activer le bouton toggle attachments si pas enfoncé
	o=o.previous.previous # bouton 
	if (controlTypes.State.PRESSED if hasattr(controlTypes, "State") else controlTypes.STATE_PRESSED) not in o.states:
		#message(u"bouton non enfoncé, on l'active")
		o.doAction() # place aussi le focus dans la liste
		return True
	else :
		while o and not o.role==14:  #list
			o=o.next
		o=o.firstChild 
		if (controlTypes.State.SELECTED if hasattr(controlTypes, "State") else controlTypes.STATE_SELECTED) not in o.states:
			o.doAction()
		o.setFocus()	
		message (o.name)
		return True
	# else :
		# message(u"Le bouton toggle attachment est enfoncé, on le relâche")
		# o.doAction()
		
	# bouton déjà enfoncé, on doit trouver la liste des PJ
	o = oPP # property page ou frame
	x = (e for e in range (o.childCount, o.childCount-10,-1)) # -5,-1
	pj=False
	for e in x:
		if getIA2Attribute (o.getChild (e), "attachmentList") : # "attachmentSize"): 
			#message (u"attachment_ trouvé")
			o =  o.getChild(e)
			pj=True
			break

	# if o.childCount == 1 :
		# message(u"Une pièce jointe.")
	# else  :
		# message( str(o.childCount) + u" pièces jointes.")
	o.setFocus()
	return True

def showHelp() :
		curAddon=addonHandler.getCodeAddon()
		helpPath=os.path.join(curAddon.path,"doc\\fr\\readme.html")
		message("Ouverture de  l'aide dans votre navigateur")
		os.startfile (helpPath)

def toSupport(tbVersion) :
	a = "ma" + "il" + "to:"
	a += "plr.listes"
	a += "@"
	a += "rptools.org"
	a +=  "?subject=Support%20" + addonVersion() + "%20Thunderbird%20" + tbVersion
	os.startfile (a)
import winUser
def getWinTitle() :
	hwFG = winUser.getForegroundWindow()
	title = winUser.getWindowText(hwFG)
	return title

def cleanedWinTitle(appMod) :
	s = getWinTitle()
	s = s.replace("Mozilla Thunderbird", "TB")
	# listgroup name repeats
	grp = strBetween(s, u"[", u"]")
	if grp == "" : return s
	# api.copyToClip("groupe " + grp)
	s= grp + ", " + appMod.regExp_nameListGroup.sub (" ",s)
	# beep(700, 50)
	# api.copyToClip(s)
	return s