# Информация за знаците (Character information) #

* Автор: Cyrille Bougot
* Съвместимост с NVDA: от 2017.3 до 2021.1
* Изтегляне на [стабилна версия][1]
* Изтегляне на [тестова версия][2]

Тази добавка позволява да се представя в съобщение информация за даден знак,
като например Unicode име, номер, категория и т.н.


## Команди

* Клавиш 2 от цифровия блок (всички клавиатурни подредби) или NVDA+. (лаптоп
  подредба): когато се натисне 4 пъти, показва информация за знака в текущия
  навигационен обект, където се намира курсора за преглед.


## Бележки

* Тази добавка предоставя и два жеста, които по подразбиране не са
  назначени:

    * Скрипт за директно показване на информация за знака под курсора за
      преглед. Тази функция по подразбиране няма зададена команда. Ако се
      затруднявате с четирикратното натискане, можете да й зададете жест в
      диалоговия прозорец "Жестове на въвеждане" на NVDA (категория "Преглед
      на текста").
    * Скрипт за показване на информация за знака в позицията на каретката
      (работи само на места, където има каретката). Той може да бъде намерен
      в категорията "Каретка" в прозореца "Жестове на въвеждане" на NVDA.

* Предоставената информация е на английски език, тъй като е част от
  нормативата на Unicode. Ако за тази добавка съществува местен превод,
  информацията се предоставя и на местния език заедно с тази на английски.
* Името от CLDR (Unicode Common Locale Data Repository (Уникод хранилище за
  общи езикови данни)) се поддържа само за версии на NVDA от 2019.1 и
  по-нови.
* За символите, написани със собствени шрифтове на Microsoft Symbol,
  Wingding (1, 2, 3) и Webding, е предоставена допълнителна информация: име
  на знака, име на шрифта и информация за съответстващия Уникод знак.


## Списък с промените

### Версия 1.6

* Съвместимост с NVDA 2021.1.

### Версия 1.5

* Подготовка за съвместимост с NVDA 2021.1 (принос от Lukasz Golonka).
* Обновяване заедно с последните промени в шаблона за добавки.

### Версия 1.4

* Добавен е скрипт за получаване на информация за знака в позицията на
  каретката (принос от Lukasz Golonka).
* Обновено до Unicode 13.0.

### Версия 1.3

* Отстранена е грешка с NVDA 2019.3.


### Версия 1.2

* Предоставя допълнителна информация за знаци, написани с шрифтове на
  Microsoft.


### Версия 1.1

* Обновления с цел поддръжка на по-нови версии на NVDA (съвместимост с
  Python 2 и 3)
* Изданията вече се изпълняват посредством appveyor


### Версия 1.0

* Първо издание.

[[!tag dev stable]]

[1]: https://addons.nvda-project.org/files/get.php?file=chari

[2]: https://addons.nvda-project.org/files/get.php?file=chari-dev
