# Базов пакет за приложения в Windows (Windows App Essentials) #

* Автори: Joseph Lee, Derek Riemer и други
* Изтегляне на [стабилна версия][1]
* Изтегляне на [тестова версия][2]
* Съвместимост с NVDA: от 2022.2 и по-нови версии

Забележка: Първоначално наречена "Базов пакет за приложения в Windows 10",
вече е преименувана на "Базов пакет за приложения в Windows" през 2021 г.,
за да поддържа Windows 10 и бъдещи версии като Windows 11. Части от тази
добавка все още ще се отнасят до оригиналното име на добавката.

Тази добавка е колекция от спомагателни модули за разни приложения в
Windows. Тя също така съдържа поправки и подобрения за разни контроли в
интерфейса на windows 10 и по-нови.

Включени са следните спомагателни модули за дадени приложения и модули за
приложения (прегледайте раздела за съответното приложение за подробности
относно включените неща):

* Cortana
* Карти
* Модерна клавиатура (панел с emoji/диктуване/въвеждане с глас/предложения
  при въвеждане от хардуерно устройство/хронология на клипборда/предложени
  действия/редактори за съвременни методи на въвеждане)
* Хора
* Настройки (настройки на системата, Windows+I)
* Достъп чрез глас (Windows 11 версия 22H2)
* Време
* Разни модули за контроли и функции, като например съобщенията за
  виртуалните работни плотове

Забележки:

* Тази добавка изисква Windows 10 версия 21H2 (компилация 19044), Windows 11
  21H2 (компилация 22000) или по-нови издания.
* Продължителността на поддръжката за дадена актуализация на функции е
  свързана с продължителността на клиентската поддръжка (Home, Pro, Pro
  Education, Pro for Workstations издания) и добавката може да прекрати
  поддръжката за актуализация на функции преди края на клиентската
  поддръжка. Вижте aka.ms/WindowsTargetVersioninfo за повече информация и
  крайните дати за поддръжка.
* Въпреки че е възможно да се инсталира на тях, тази добавка не поддържа
  Windows 10 Enterprise LTSC (Long-Term Servicing Channel) и Windows Server.
* Ако е инсталирана добавката "Обновяване на добавките" и е включено
  обновяването на добавките във фонов режим, "Базов пакет за приложения в
  Windows" няма да се инсталира на неподдържани издания на Windows.
* Не всички функции от компилациите на Windows Insider Preview ще се
  поддържат, още повече за функциите, въведени само за ограничен брой
  потребители на Windows Insider в dev канала. За бета канала се поддържа
  само най-новата компилация (22623).
* Някои функции на добавката са в момента или ще бъдат включени в екранния
  четец NVDA.
* Някои приложения поддържат режим на компактно припокриване (например
  "Задържане отгоре" в приложението "Калкулатор") и този режим няма да
  работи правилно с преносимата версия на NVDA.
* За най-добро изживяване с приложения, които вграждат уеб технологии и
  съдържание, като менюто "Старт" и неговото контекстно меню, включете
  настройката "Автоматичен режим на фокус при промяна във фокуса" от панела
  с настройки за режима на разглеждане на NVDA.

За списък на промените, направени между всяко издание на добавката, вижте
документа ["Списък с промените за всяко издание на добавката"][3].

## Общи

* В допълнение към манипулаторите на UIA събития, предоставени от NVDA, се
  разпознават следните UIA събития и свойства: drag start/cancel/complete
  (разпознавани като state change event), drag drop effect, drag item is
  grabbed, drop target effect. Поддръжката за тях е включена в NVDA 2022.4.
* При отваряне, затваряне или превключване между виртуалните работни
  плотове, NVDA ще съобщава името на текущия работен плот (например "Работен
  плот 2").
* Когато подреждате закачени елементи (плочки в Windows 10) в менюто "Старт"
  или бутоните за бързи действия в работния център с Alt+Shift+стрелките,
  NVDA ще съобщава "влачене" и/или ефекти на влачене и пускане преди и по
  време на влачене на елементи, съответно. Това е включено в NVDA 2022.4.
* Съобщения като тези за промените в силата на звука/яркостта/заглушаването
  на микрофона (Windows 11 22H2 и по-нови версии) във File Explorer и
  известията за обновяване на приложения от Microsoft Store могат да бъдат
  потиснати чрез изключване на опцията "Докладвай известията" в категорията
  "Представяне на обектите" в настройките на NVDA.
* В Windows 11 NVDA ще докладва акцентите от търсенето (search highlights) в
  менюто "Старт", когато то бъде отворено. Това вече е внедрено в NVDA
  2023.1.

## Cortana

* Текстовите отговори от Cortana се съобщават в повечето случаи.
* NVDA няма да изговаря нищо, докато комуникирате с Cortana посредством
  глас.

## Карти

* NVDA възпроизвежда звук като ориентир за дадено местоположение от картата.

## Модерна клавиатура

Това включва панел за емоджи, хронология на клипборда, диктуване/гласово
въвеждане, предложения при хардуерно въвеждане, предложени действия и
редактори за съвременни методи за въвеждане на определени езици в Windows 10
и 11. Когато преглеждате емоджи, за най-добро изживяване, включете опцията
за използване на данни от Уникод консорциума от настройките за реч на NVDA и
задайте нивото на пунктуацията на "някои" или по-високо. Когато поставяте от
хронологията на клипборда в Windows 10, натиснете клавиша за интервал вместо
клавиша Enter, за да поставите избрания елемент.

* В Windows 10, когато е избрана група емоджи (включително групите за
  каомоджи и символи), NVDA вече няма да премества навигационния обект към
  определени емоджи.
* В хронологията на клипборда на Windows 11, режимът на разглеждане ще бъде
  изключен по подразбиране, с цел да позволи на NVDA да докладва елементите
  от менюто за записите от хронологията на клипборда.
* В Windows 11 22H2 Moment 1 и по-нови, NVDA ще докладва предложените
  действия, когато съвместими данни, като например телефонни номера, бъдат
  копирани в клипборда.

## Хора

* При търсене на контакти ще бъде съобщено първото предложение.

## Настройки

* NVDA ще докладва името на контролата за опционалната актуализация за
  качеството, ако има такава (връзка за изтегляне и инсталиране в Windows
  10, бутон за изтегляне в Windows 11).
* В Windows 11, елементите от адресната лента биват правилно разпознавани.
* В Windows 10 и 11 22H2 и по-нови, NVDA ще прекъсва речта и ще докладва за
  обновления на състоянието на Windows Update, докато изтеглянето и
  инсталирането напредва. Това може да доведе до прекъсване на говора при
  навигация в приложението Настройки, докато актуализациите се изтеглят и
  инсталират. Ако използвате Windows 11 22H2 и по-нови версии, ако
  избирателното регистриране на UIA събития е включено, трябва да преместите
  фокуса в списъка с актуализации веднага щом се появят, за да може NVDA да
  докладва напредъка на актуализирането.

## Достъп чрез глас

Това се отнася до функцията "Достъп чрез глас" ("Voice Access"), представена
в Windows 11 версия 22H2.

* NVDA ще докладва състоянието на микрофона при превключването му от
  интерфейса на "Достъп чрез глас".

## Време

* Раздели като "Прогноза за времето" и "Карти" биват правилно разпознати
  като раздели (принос от Derek Riemer).
* Когато четете прогнозата, използвайте стрелките наляво и надясно за
  преместване между елементите. Използвайте стрелките нагоре и надолу, за да
  прочетете отделните елементи. Например, като натиснете стрелка надясно,
  може да се съобщи нещо от типа на "Вторник 6, Висока ‎‎22°, Ниска ‎‎13°,
  Облачно". При натискане на стрелка надолу ще се съобщи "Вторник". При
  следващото натискане ще се съобщи следващия елемент (например
  температурата). Към момента това работи за дневната и почасовата прогнози.

[[!tag dev stable]]

[1]: https://addons.nvda-project.org/files/get.php?file=w10

[2]: https://addons.nvda-project.org/files/get.php?file=w10-dev

[3]: https://github.com/josephsl/wintenapps/wiki/w10changelog
