# Windows App Essentials (Поліпшення для застосунків Windows #

* Автори: Joseph Lee, Derek Riemer та інші
* Завантажити [стабільну версію][1]
* Завантажити [версію в розробці][2]
* Сумісність з NVDA: 2022.2 і новіші

Примітка: спочатку додаток називався Windows 10 App Essentials, у 2021 році
його було перейменовано на Windows App Essentials для підтримки Windows 10 і
майбутніх випусків, таких як Windows 11. Частини цього додатка все ще
посилатимуться на оригінальну назву додатка.

Цей додаток є набором модулів програм для різноманітних сучасних програм
Windows, а також удосконаленням та виправленням певних елементів керування,
доступних у Windows 10 і вище.

Включено наведені нижче модулі додатків або модулі підтримки для деяких
додатків (перегляньте розділ кожного додатка, щоб дізнатися, що включено):

* Cortana
* Карти
* Сучасна клавіатура (панель емодзі/диктування/голосове введення/пропозиції
  введення з апаратної клавіатури/історія буфера обміну/пропоновані
  дії/сучасні редактори методів вводу)
* Люди
* Настройки (параметри системи, Windows+I)
* Голосовий доступ (Windows 11 22H2)
* Погода
* Різноманітні модулі для елементів керування й функцій, таких як оголошення
  віртуальних робочих столів

Примітки:

* Для цього додатка потрібна Windows 10 21H2 (збірка 19044), 11 21H2 (збірка
  22000) або вище.
* Тривалість підтримки оновлень функцій прив'язана до тривалості підтримки
  користувачів (версії Home, Pro, Pro Education, Pro для робочих станцій), і
  додаток може припинити підтримку оновлення функцій до закінчення підтримки
  користувачів. Додаткову інформацію й дати підтримки див. на
  aka.ms/WindowsTargetVersioninfo.
* Цей додаток не підтримує версії Windows Enterprise LTSC (Long-Term
  Servicing Channel) і Windows Server, Хоча встановлення на ці версії
  можливе.
* Якщо встановлено Оновлювач додатків та увімкнено фонове оновлення
  додатків, Windows App Essentials взагалі не встановлюватиметься у версіях
  Windows, які не підтримуються.
* Не всі функції зі збірок Windows Insider Preview підтримуватимуться,
  особливо функції, представлені для підгрупи Windows Insiders у каналі
  розробників. Для бета-каналу підтримується лише остання збірка (22623).
* Деякі функції додатка є або будуть частиною NVDA.
* Деякі програми підтримують компактний режим накладання (завжди зверху в
  Калькуляторі, наприклад), і цей режим не буде працювати належним чином з
  переносною версією NVDA.
* Для найкращого досвіду роботи з програмами, які включають веб-технології
  та вміст, наприклад меню «Пуск» і його контекстне меню, увімкніть параметр
  «Автоматичний перехід в режим фокуса при зміні фокуса» у розділі "Режим
  огляду" налаштувань NVDA.

Перелік змін, внесених між випусками додатка, наведено у документі [журнал
змін випусків додатка][3].

## Загальне

* На додаток до обробників подій UIA, що надаються NVDA, розпізнаються
  наступні події та властивості UIA: початок/скасування/завершення
  перетягування (розпізнається як подія зміни стану), ефект перетягування,
  захоплення елемента перетягування, ефект перетягування цілі. Ці події
  тепер є частиною NVDA 2022.4.
* При відкритті, закритті або перемиканні між віртуальними робочими столами
  NVDA буде називати ім'я активного віртуального робочого столу (наприклад,
  робочий стіл 2).
* При перетягуванні елементів, таких як упорядкування закріплених записів
  (плиток у Windows 10) у меню "Пуск" або швидких дій Центру дій за
  допомогою клавіш Alt+Shift+стрілки, NVDA буде повідомляти про
  "перетягування" та/або ефекти перетягування до і під час перетягування
  елементів, відповідно, до і під час перетягування. Наразі це є частиною
  NVDA 2022.4.
* Такі повідомлення, як зміни гучності/яскравості/вимкнення мікрофона
  (Windows 11 22H2 і новіші версії) у файловому провіднику та сповіщення про
  оновлення застосунків з Microsoft Store можна вимкнути, вимкнувши читання
  сповіщень у налаштуваннях представлення об'єкта NVDA.
* У Windows 11 NVDA буде повідомляти про основні моменти пошуку в меню
  "Пуск" при його відкритті. Тепер це є частиною NVDA 2023.1.

## Cortana

* Текстові відповіді від Cortana оголошуються в більшості випадків.
* NVDA буде мовчати під час звернення до Cortana голосом.

## Карти

* NVDA відтворює звуковий сигнал для локацій на карті.

## Сучасна клавіатура

Це включає панель емодзі, історію буфера обміну, диктування/голосовий ввід,
пропозиції при апаратному введенні, пропоновані дії та сучасні редактори
методів введення для певних мов у Windows 10 і 11. Для найкращого перегляду
емодзі увімкніть опцію "Включити дані Консорціуму Юнікоду (включно з емодзі)
при обробці знаків та символів" у розділі "Мовлення" налаштувань NVDA і
встановіть рівень символів і знаків пунктуації на «деякі» або вище. Під час
вставлення з історії буфера обміну в Windows 10 натисніть клавішу пробілу
замість клавіші Enter, щоб вставити вибраний елемент.

* На панелі емодзі Windows 10, коли вибрано групу емодзі (зокрема каомодзі
  та групу символів), NVDA більше не переміщуватиме об’єкт навігатора до
  певних емодзі.
* В історії буфера обміну Windows 11 режим огляду початково буде вимкнено,
  щоб дозволити NVDA зачитувати пункти меню записів буфера обміну.
* У Windows 11 22H2 Момент 1 і пізніше NVDA буде оголошувати пропоновані
  дії, коли сумісні дані, такі як телефонні номери, копіюються в буфер
  обміну.

## Люди

* При пошуку контактів буде оголошено першу пропозицію.

## Настройки

* NVDA оголосить назву додаткового контролю якості оновлення, якщо він буде
  присутній (посилання «Завантажити та встановити зараз» у Windows 10,
  кнопка «Завантажити» у Windows 11).
* У Windows 11 елементи панелі навігації розпізнаються належним чином.
* У Windows 10 і 11 22H2 і новіших версіях NVDA перериватиме мовлення та
  повідомлятиме про оновлення статусу Windows Update під час завантаження та
  встановлення. Це може призвести до переривання мовлення під час навігації
  програмою «Настройки» протягом завантаження та встановлення оновлень. Якщо
  ви використовуєте Windows 11 22H2 і новішу версію, якщо ввімкнено
  вибіркову реєстрацію подій UIA, ви повинні перемістити фокус до списку
  оновлень, щойно вони з’являться, щоб NVDA могла оголосити про перебіг
  оновлення.

## Голосовий доступ

Це стосується функції голосового доступу, що представлена в Windows 11 22H2.

* NVDA сповістить про стан мікрофона під час перемикання мікрофона з
  інтерфейсу голосового доступу.

## Погода

* Такі вкладки, як «погода» і «карти», розпізнаються як правильні вкладки
  (патч від Дерека Рімера).
* При читанні прогнозу використовуйте стрілки вліво та вправо для
  переміщення між пунктами. Для читання окремих пунктів використовуйте
  стрілки вгору та вниз. Наприклад, при натисканні стрілки вправо може
  з'явитися повідомлення "Понеділок: 79 градусів, мінлива хмарність, ...",
  при натисканні стрілки вниз з'явиться "Понеділок", а при повторному
  натисканні - наступний пункт (наприклад, температура). Наразі це працює
  для щоденних та погодинних прогнозів.

[[!tag dev stable]]

[1]: https://addons.nvda-project.org/files/get.php?file=w10

[2]: https://addons.nvda-project.org/files/get.php?file=w10-dev

[3]: https://github.com/josephsl/wintenapps/wiki/w10changelog
