# -*- coding: iso-8859-15 -*-
# modifie par Daniel Poiraud, AVH16. version 3.3 du 22/04/2022.
#A part of NonVisual Desktop Access (NVDA)
import winUser
from winUser import *
#import textInfos
import api
import appModuleHandler
import speech
from ui import message
import ctypes
from ctypes import windll
from ctypes import * 
from ctypes.wintypes import * 
from keyboardHandler import KeyboardInputGesture
from NVDAObjects import NVDAObject
from time import sleep
from UIAHandler import handler
clientObject = handler.clientObject
user32 = windll.user32

def getSpeechMode():
	try:
		return speech.getState().speechMode
	except AttributeError:
		return speech.speechMode
def setSpeechMode(mode):
	try:
		speech.setSpeechMode(mode)
	except AttributeError:
		speech.speechMode = mode

def setSpeechMode_off():
	try:
		speech.setSpeechMode(speech.SpeechMode.off)
	except AttributeError:
		speech.speechMode = speech.speechMode_off
	
def clicGauche (x,y):
	winUser.setCursorPos(x,y)
	mouse_event(MOUSEEVENTF_LEFTDOWN,0,0,None,None)
	mouse_event(MOUSEEVENTF_LEFTUP,0,0,None,None)
	
class PourAutoCompletion():
	
	def initOverlayClass(self):
		self.iX = self.iY = self.iB = 0
		obj = api.getFocusObject()
		self.versionWLM = int(obj.appModule.productVersion.split(".")[0])	
		self.bindGestures({
		"kb:control+shift+home":"nombreAdresses",
		"kb:control+shift+end":"nombreAdresses",
		"kb:control+shift+rightArrow":"nombreAdresses",
		})
			
	def dimZoneAdresses (self) :
		try :
			element = clientObject.ElementFromHandle(winUser.getDesktopWindow()).FindFirst(4,clientObject.CreateAndCondition(clientObject.CreatePropertyCondition(30003,50033),clientObject.CreatePropertyCondition(30012,"MailWellsAutoCompleteClass")))
		except :
			return	None
		(x,y,l,h) =element.GetCurrentPropertyValue(30001)  
		dim =(int(x),int(y),int(y+h),int(x+l) )
		return dim
				
	def script_nombreAdresses (self,gesture): 	
		dim =self.dimZoneAdresses()
		if dim==None:
			message("Pas d'adresse")
			return
		self.iX, self.iY, self.iB, self.iH, self.iX1 = dim[0], dim[1], dim[2], dim[1]+12, dim[3]-80
		winUser.setCursorPos(self.iX1,self.iY+12) 
		nbAdresses =int(round((self.iB-self.iY)/22))
		if nbAdresses ==1: 
			message(u"une adresses affiche.")
		else : 
			message(u"%s adresses affiches." %nbAdresses)		
		self.bindGestures({
		"kb:control+rightArrow":"validerAdresse",
		"kb:escape":"echapper",
		"kb:control+downArrow":"adresseSuivante", 
		"kb:control+upArrow":"adressePrecedente"})			
				
	def script_validerAdresse (self,gesture): 					
		clicGauche (self.iX1,self.iH) 
		sleep(0.1)
		winUser.setCursorPos(self.iX1+100,self.iY-15)		
		sleep(0.1)
		for e in ("kb:control+downArrow","kb:control+upArrow","kb:escape") :self.removeGestureBinding(e)
		sleep(0.2)
		nomZone = api.getFocusObject().name
		oCondition  =clientObject.CreateAndCondition(clientObject.CreatePropertyCondition(30003,50004),clientObject.CreatePropertyCondition(30005,nomZone))
		element = clientObject.ElementFromHandle(user32.GetForegroundWindow()).FindFirst(4,oCondition)
		nomAdresse =	element.GetCurrentPropertyValue(30045)  #UIA_ValueValuePropertyId 
		if nomAdresse :
			nomAdresse =nomAdresse.split (";")[-2]  
			nomAdresse =nomAdresse.replace("<","")
			nomAdresse =nomAdresse.replace(">","")
			message(u"Ajout, ")
			message(nomAdresse) 
	
	def script_echapper (self,gesture): 	
		message(u"annul")
		KeyboardInputGesture.fromName("Escape").send()
		sleep(0.2)
		winUser.setCursorPos(self.iX1+100,self.iY+2)		
		for e in ("kb:control+downArrow","kb:control+upArrow","kb:control+rightArrow") :self.removeGestureBinding(e) 
				
	def script_adresseSuivante (self,gesture): 
		winUser.setCursorPos(self.iX1+100,self.iH)
		if self.iH+22>self.iB : 
			self.iH = self.iY+12
		else : 
			self.iH+=22
		sleep(0.2)	
		winUser.setCursorPos(self.iX1,self.iH)  

	def script_adressePrecedente (self,gesture): 	
		winUser.setCursorPos(self.iX1+100,self.iH)
		if self.iH-22<self.iY+10 : 
			self.iH = self.iB-12
		else : 
			self.iH-=22
		sleep(0.2)
		winUser.setCursorPos(self.iX1,self.iH)  
		
	def allerContenu (self): 
		try :
			oCondition1  =clientObject.CreatePropertyCondition(30003,50033)
			oCondition2  =clientObject.CreatePropertyCondition(30012,"Internet Explorer_Server") #"CtrlNotifySink") 
			oCondition  =clientObject.CreateAndCondition(oCondition1,oCondition2) 
			if clientObject.ElementFromHandle(user32.GetForegroundWindow()).FindFirst(4,oCondition):
				clientObject.ElementFromHandle(user32.GetForegroundWindow()).FindFirst(4,oCondition).setFocus()	
		except : 
			message(u"Zone de rdaction non atteinte.")		

class PourBDDSelectionContacts():

	def script_flecheBas (self,gesture): 	
		if api.getForegroundObject().firstChild.children[4].role == 0 and api.getForegroundObject().firstChild.children[4].childCount == 0:
			message(api.getForegroundObject().firstChild.children[4].name)
			return
		KeyboardInputGesture.fromName("downArrow").send()
		
	def script_zoneRecherche (self,gesture): 
		if api.getFocusObject().role== 8 and api.getFocusObject().description=="Rechercher des contacts" : #ROLE_EDITABLETEXT
			message(u"Vous tes dans la zone de recherche")
			return
		oCondition  =clientObject.CreatePropertyCondition(30003,50004) #UIA_ControlTypePropertyId  UIA_EditControlTypeId
		element = clientObject.ElementFromHandle(user32.GetForegroundWindow()).FindFirst(4,oCondition)
		if not element : message(u"Zone de recherche non trouve")
		(x,y,l,h) =element.GetCurrentPropertyValue(30001)		#UIA_BoundingRectanglePropertyId 
		clicGauche (int(x)+50,int(y)+8)		
		
	__gestures={ 
"kb:Alt+K":"zoneRecherche",
"kb:downArrow":"flecheBas",
}

class PourCorrection():
	
	def initOverlayClass(self):
		self.bindGestures({
		"kb:Alt+A":"motAbsentDico",
		"kb:Alt+R":"remplacer",
		"kb:Alt+T":"remplacerTout",
		"kb:Alt+G":"ignorer",
		"kb:Alt+N":"ignorerTout",
		"kb:Alt+M":"modifier",
		"kb:Alt+E":"modifierTout",
		"kb:Alt+I":"ignorer9",
		"kb:Alt+O":"ajouter",
		}	)

	def event_valueChange(self) : 
		oldSpeechMode = getSpeechMode()
		setSpeechMode_off()
		api.processPendingEvents()
		sleep(0.1)
		setSpeechMode(oldSpeechMode)
		self.vocalisationMotACorriger()
		
	def pourCorrecteur (self): 	
		if api.getForegroundObject().name == u"Vrifier l'orthographe" or api.getForegroundObject().name == u"Orthographe":
			obj =api.getFocusObject()
			o = api.getForegroundObject()
			if api.getForegroundObject().name == u"Vrifier l'orthographe" and u"Remplacer par" in obj.name :
				o = o.children[0]
				o = o.next
				nom1 =(o.name)
				sleep(0.1)
				o = o.next
			if api.getForegroundObject().name == u"Orthographe" and u"Absent du dictionnaire:"  in obj.name :
				nom1 = obj.value			
				sleep(0.1)
				o = obj.parent.next
			sleep(0.1)				
			o = o.next 
			nom2 = o.simpleFirstChild.value
			o = o.next.next
			nbSuggestions = o.simpleFirstChild.childCount	
			if nom2 :	return (nom1, nom2, nbSuggestions)
			else : return ("", "", 0)
			
	def epeler(self,nom) :
		for c in nom :
			message (c)
			
	def vocalisationMotACorriger(self) :
		try :
			(nom1, nom2, nbSuggestions) = self.pourCorrecteur()
		except:
			return
		message("Absent du dictionnaire : %s" %nom1)
		self.epeler(nom1)
		message("Remplacer par: %s" %nom2)
		self.epeler(nom2)
		
	def script_motAbsentDico(self,gesture):
		try :
			(nom1, nom2, nbSuggestions) = self.pourCorrecteur()
		except:
			return		
		self.vocalisationMotACorriger()
		if nbSuggestions ==1 : message("Une suggestion.")
		elif nbSuggestions>1 : message("%s suggestions." %nbSuggestions)
			 
	def script_remplacer(self,gesture):
		if winUser.getWindowText(winUser.getForegroundWindow())==u"Vrifier l'orthographe" :
			message(u"Remplacer.")  
			sleep(0.6)
		KeyboardInputGesture.fromName("Alt+R").send()
	
	def script_remplacerTout(self,gesture):
		if winUser.getWindowText(winUser.getForegroundWindow())==u"Vrifier l'orthographe" :
			message(u"Remplacer tout.")  
			sleep(0.6)
		if winUser.getWindowText(winUser.getForegroundWindow())=="Orthographe":
			message(u"Tout ignorer.")  
			sleep(0.6)			
		KeyboardInputGesture.fromName("Alt+T").send()
		
	def script_modifier(self,gesture):
		if winUser.getWindowText(winUser.getForegroundWindow())=="Orthographe":
			message(u"Remplacer.")  
			sleep(0.6)
		KeyboardInputGesture.fromName("Alt+M").send()
	
	def script_modifierTout(self,gesture):
		if winUser.getWindowText(winUser.getForegroundWindow())=="Orthographe":
			message(u"Tout remplacer.")  
			sleep(0.6)
		KeyboardInputGesture.fromName("Alt+E").send()		
		
	def script_ignorer(self,gesture):
		if winUser.getWindowText(winUser.getForegroundWindow())==u"Vrifier l'orthographe" :
			message(u"Ignorer.")  
			sleep(0.6)
		KeyboardInputGesture.fromName("Alt+G").send()
		
	def script_ignorerTout(self,gesture):
		if winUser.getWindowText(winUser.getForegroundWindow())==u"Vrifier l'orthographe" :
			message(u"Ignorer tout.")  
			sleep(0.6)
		KeyboardInputGesture.fromName("Alt+N").send()
		
	def script_ignorer9(self,gesture):
		if winUser.getWindowText(winUser.getForegroundWindow())=="Orthographe":
			message(u"Ignorer.")  
			sleep(0.6)
		KeyboardInputGesture.fromName("Alt+I").send()
		
	def script_ajouter(self,gesture):
		if winUser.getWindowText(winUser.getForegroundWindow())==u"Vrifier l'orthographe" or winUser.getWindowText(winUser.getForegroundWindow())=="Orthographe":
			message(u"Ajouter.")  
			sleep(0.6)
		KeyboardInputGesture.fromName("Alt+O").send()